subroutine contact_zones(xyoutwl,icenode,icenode_no,ipair_in_id,ipair_out_id,hpair_in_id,hpair_out_id,intsct_in,intsct_out,lh,c_rgns,id1,id3,ipair_id_temp,hpair_id_temp,ipair_id_temp2,hpair_id_temp2,intsct_temp,intsct_temp2,inode_id)
implicit none

real(kind=8), parameter :: zero = 1.0d-16, zero2 = 1.0d-2, zero4 = 1.0d-4, zero8 = 1.0d-8
integer(kind = 4), parameter :: wl_dim = 100
integer(kind = 4), parameter :: wl_dim_half = 50

real(kind = 8) :: xyoutwl(2,wl_dim)
real(kind = 8) :: icenode(2,20000)
integer :: icenode_no
integer :: ipair_in_id(200), ipair_out_id(200)
integer :: hpair_in_id(200), hpair_out_id(200)
real(kind = 8) :: intsct_in(2,200), intsct_out(2,200)
real(kind = 8) :: lh(200)
integer :: c_rgns

integer :: i,j
real(kind = 8) :: xyoutwl_suba(2,wl_dim+1)
real(kind = 8) :: t1(2), t2(2), t1t2(2), t1p(2)
integer :: inode_id(20000)
real(kind = 8) :: crp(wl_dim)
integer :: crp_0
real(kind = 8) :: x_1,y_1,x_2,y_2
integer :: id1, id3, id4, id5
integer :: id2(20000)
real(kind = 8) :: x_3,y_3,x_4,y_4
real(kind = 8) :: xc,yc
integer :: intsct
real(kind = 8) :: intsct_temp(2,400), intsct_temp2(2,400)
integer :: ipair_id_temp(400), hpair_id_temp(400), ipair_id_temp2(400), hpair_id_temp2(400)
real(kind = 8) :: pta(2), ptb(2), temp2(2)
real(kind = 8) :: dab
integer :: id_distance2D, temp
real(kind = 8) :: lh_temp
integer :: nd_no, lft, rgt
real(kind = 8) :: nd(10)

intsct_temp = 0.0d0
ipair_id_temp = 0
hpair_id_temp = 0
intsct = -10
nd = 0.0d0

forall(i=1:2,j=1:wl_dim)
    xyoutwl_suba(i,j) = xyoutwl(i,j)
end forall
forall(i=1:2)
    xyoutwl_suba(i,wl_dim+1) = xyoutwl(i,1)
end forall

inode_id = 0
do i = 1,icenode_no
    nd_no = 0
    lft = 0
    rgt = 0
    do j = 1,wl_dim
        if (((xyoutwl_suba(2,j)>icenode(2,i)).and.(xyoutwl_suba(2,j+1)<icenode(2,i))).or.((xyoutwl_suba(2,j)<icenode(2,i)).and.(xyoutwl_suba(2,j+1)>icenode(2,i)))) then
        !if ((xyoutwl_suba(2,j)-icenode(2,i))*(xyoutwl_suba(2,j+1)-icenode(2,i))<0.0d0) then
            nd_no = nd_no+1
            if (dabs(xyoutwl_suba(2,j+1) - xyoutwl_suba(2,j))>zero8) then
                nd(nd_no) = ((icenode(2,i)-xyoutwl_suba(2,j))/(xyoutwl_suba(2,j+1) - xyoutwl_suba(2,j)))*(xyoutwl_suba(1,j+1) - xyoutwl_suba(1,j)) + xyoutwl_suba(1,j)
            else
                if ((icenode(1,i)-xyoutwl_suba(1,j))*(icenode(1,i)-xyoutwl_suba(1,j+1))<=zero8) then   ! out
                    goto 666
                else
                    nd(nd_no) = 0.5d0*(xyoutwl_suba(1,j)+xyoutwl_suba(1,j+1))
                end if    
            end if
        !else if ((xyoutwl_suba(2,j)-icenode(2,i))*(xyoutwl_suba(2,j+1)-icenode(2,i))>zero8) then
        !    continue
        else if (xyoutwl_suba(2,j)==icenode(2,i).or.xyoutwl_suba(2,j+1)==icenode(2,i)) then
            write(*,*) 'ec #1'
            pause
        else
            continue
        end if
    end do
    
    if (nd_no>=1) then
        do j = 1,nd_no
            if (nd(j)<icenode(1,i)) then
                lft = lft+1
            else if (nd(j)>icenode(1,i)) then
                rgt = rgt+1
            else
                !write(*,*) 'eco #2'
                !pause
            end if
        end do
    end if
    
    if (mod(lft,2)==0.and.mod(rgt,2)==0) then
        inode_id(i) = 0                                     ! out
    else if (mod(lft,2)==1.and.mod(rgt,2)==1) then
        inode_id(i) = 1                                     ! in
    else
        !write(*,*) 'ec#3'
        !pause
    end if
666 continue
end do

id1 = 0
do i = 1,icenode_no-1

    x_1 = icenode(1,i)
    y_1 = icenode(2,i)
    x_2 = icenode(1,i+1)
    y_2 = icenode(2,i+1)
    
    id2(i) = 0
    do j = 1,wl_dim
        x_3 = xyoutwl_suba(1,j)
        y_3 = xyoutwl_suba(2,j)
        x_4 = xyoutwl_suba(1,j+1)
        y_4 = xyoutwl_suba(2,j+1)
        
        call crossxy(x_1,y_1,x_2,y_2,x_3,y_3,x_4,y_4,xc,yc,intsct)
        
        if ((intsct == 2).or.(intsct == 0)) then
            cycle                                                      ! begin next loop
        !else if (intsct == -1) then
            !write(*,*) 'wa04'
            !pause
        else if (intsct == 1) then
            id1 = id1 + 1
            id2(i) = id2(i) + 1
            intsct_temp(1,id1) = xc
            intsct_temp(2,id1) = yc
            ipair_id_temp(id1) = i
            hpair_id_temp(id1) = j
        else
            write(*,*) 'ea04'
            pause
        end if
        
    end do
end do

if (id1==0) then
    c_rgns = 0
    hpair_in_id = 0
    hpair_out_id = 0
    ipair_in_id = 0
    ipair_out_id = 0
    lh = -1.0d0
    intsct_in = 1.2345d0
    intsct_out = 1.2345d0
    return
else if (id1==1) then
    c_rgns = 0
    hpair_in_id = -1
    hpair_out_id = -1
    ipair_in_id = -1
    ipair_out_id = -1
    lh = -2.0d0
    intsct_in = 1.23456d0
    intsct_out = 1.23456d0
    return
else                    ! id1 = 2,3,4,....
    id3 = id1
    id4 = 1
    intsct_temp2 = 0.0d0
    ipair_id_temp2 = 0
    hpair_id_temp2 = 0
    intsct_temp2(1,1) = intsct_temp(1,1)
    intsct_temp2(2,1) = intsct_temp(2,1)
    ipair_id_temp2(1) = ipair_id_temp(1)
    hpair_id_temp2(1) = hpair_id_temp(1)

    do i = 1,id1-1
        lh_temp = dsqrt((intsct_temp(1,i)-intsct_temp(1,i+1))*(intsct_temp(1,i)-intsct_temp(1,i+1))+(intsct_temp(2,i)-intsct_temp(2,i+1))*(intsct_temp(2,i)-intsct_temp(2,i+1)))
        if (lh_temp<=zero2) then
            id3 = id3-1
        else
            id4 = id4 + 1
            intsct_temp2(1,id4) = intsct_temp(1,i+1)
            intsct_temp2(2,id4) = intsct_temp(2,i+1)
            ipair_id_temp2(id4) = ipair_id_temp(i+1)
            hpair_id_temp2(id4) = hpair_id_temp(i+1)
        end if
    end do

    if (id3/=id4) then
        write(*,*) 'ea909'
        write(*,*) 'id3,id4:',id3,id4
        pause
    end if

    if (id3<=1) then
        c_rgns = 0
        hpair_in_id = -2
        hpair_out_id = -2
        ipair_in_id = -2
        ipair_out_id = -2
        lh = -3.0d0
        intsct_in = 1.234567d0
        intsct_out = 1.234567d0
        return
    else                    ! id3 = 2,3,4,....
        if ((ipair_id_temp2(1)==ipair_id_temp2(2)).and.hpair_id_temp2(1)==1.and.hpair_id_temp2(2)==wl_dim) then
            temp = hpair_id_temp2(1)
            hpair_id_temp2(1) = hpair_id_temp2(2)
            hpair_id_temp2(2) = temp
            temp2(1) = intsct_temp2(1,1)
            temp2(2) = intsct_temp2(2,1)
            intsct_temp2(1,1) = intsct_temp2(1,2)
            intsct_temp2(2,1) = intsct_temp2(2,2)
            intsct_temp2(1,2) = temp2(1)
            intsct_temp2(2,2) = temp2(2)
        end if
        
        if (hpair_id_temp2(1)==1.and.hpair_id_temp2(2)>wl_dim_half+1) then
            id3 = id3-2
            do i = 2,id3-2
                intsct_temp2(1,i) = intsct_temp(1,i+2)
                intsct_temp2(2,i) = intsct_temp(2,i+2)
                ipair_id_temp2(i) = ipair_id_temp(i+2)
                hpair_id_temp2(i) = hpair_id_temp(i+2)                
            end do
        end if
        
        intsct_in(1,1) = intsct_temp2(1,1)
        intsct_in(2,1) = intsct_temp2(2,1)
        ipair_in_id(1) = ipair_id_temp2(1)
        hpair_in_id(1) = hpair_id_temp2(1)

        id5 = 1
        do i = 1,id3-1
            if (ipair_id_temp2(i+1) > ipair_id_temp2(i)) then
                do j = ipair_id_temp2(i)+1,ipair_id_temp2(i+1)
                    if (inode_id(j) == 0) then
                        intsct_out(1,id5) = intsct_temp2(1,i)
                        intsct_out(2,id5) = intsct_temp2(2,i)
                        ipair_out_id(id5) = ipair_id_temp2(i)
                        hpair_out_id(id5) = hpair_id_temp2(i)
                        id5 = id5+1
                        intsct_in(1,id5) = intsct_temp2(1,i+1)
                        intsct_in(2,id5) = intsct_temp2(2,i+1)
                        ipair_in_id(id5) = ipair_id_temp2(i+1)
                        hpair_in_id(id5) = hpair_id_temp2(i+1)
                        exit
                    end if
                end do
            else
                intsct_out(1,id5) = intsct_temp2(1,i+1)
                intsct_out(2,id5) = intsct_temp2(2,i+1)
                ipair_out_id(id5) = ipair_id_temp2(i+1)
                hpair_out_id(id5) = hpair_id_temp2(i+1)                    
            end if
        end do
        intsct_out(1,id5) = intsct_temp2(1,id3)
        intsct_out(2,id5) = intsct_temp2(2,id3)
        ipair_out_id(id5) = ipair_id_temp2(id3)
        hpair_out_id(id5) = hpair_id_temp2(id3)

        c_rgns = id5

        do i = 1,c_rgns
            lh(i) = dsqrt((intsct_out(1,i)-intsct_in(1,i))*(intsct_out(1,i)-intsct_in(1,i))+(intsct_out(2,i)-intsct_in(2,i))*(intsct_out(2,i)-intsct_in(2,i)))
        end do
    
    end if
end if

end subroutine
!b-------------------------------------------------------------------------
! relations between two line sections; cross point between two lines
subroutine crossxy(x_1,y_1,x_2,y_2,x_3,y_3,x_4,y_4,xc,yc,intsct)
implicit none

real(kind = 8), parameter :: zero = 1.0d-16
real(kind = 8) :: x_1, y_1, x_2, y_2, x_3, y_3, x_4, y_4
real(kind = 8) :: xc, yc, d                       ! xc, yc - section intersection; xcg, ycg - general intersection between lines.
real(kind = 8) :: line_pt1(2),line_pt2(2),test_p(2),n_pt(2)
real(kind = 8) :: dab
integer :: intsct                  ! 2 means no intersection between sections, but between lines; 0 means parallel or coincide
integer :: id_distance2D, id_projection

xc = -1.9d0
yc = -1.9d0
intsct = -2

! to make sure two line sections exist
if((((x_1-x_2)*(x_1-x_2)+(y_1-y_2)*(y_1-y_2))<=zero).or.(((x_3-x_4)*(x_3-x_4)+(y_3-y_4)*(y_3-y_4))<=zero)) then
    write(*,*) 'eb01' 
    pause
else                ! two sections exist
    d = (y_2-y_1)*(x_4-x_3)-(y_4-y_3)*(x_2-x_1)

    if(dabs(d)<=zero) then
    
        !line_pt1(1) = x_1
        !line_pt1(2) = y_1
        !line_pt2(1) = x_2
        !line_pt2(2) = y_2
        !test_p(1) = x_3
        !test_p(2) = y_3
        !call projection2D(line_pt1,line_pt2,test_p,n_pt,id_projection)
        !if (id_projection == 1) then
            intsct = 0                  ! parallel
            !xc = 1.0d20
            !yc = 1.0d20
        !else
            !intsct = -1
            xc = 1.0d20
            yc = 1.0d20
        !end if
    else
        xc = ((x_2-x_1)*(x_4-x_3)*(y_3-y_1)+(y_2-y_1)*(x_4-x_3)*x_1-(y_4-y_3)*(x_2-x_1)*x_3)/d
        yc = ((y_2-y_1)*(y_4-y_3)*(x_3-x_1)+(x_2-x_1)*(y_4-y_3)*y_1-(x_4-x_3)*(y_2-y_1)*y_3)/(-d)
        if (((xc-x_1)*(xc-x_2)<=0.0d0).and.((xc-x_3)*(xc-x_4)<=0.0d0).and.((yc-y_1)*(yc-y_2)<=0.0d0).and.((yc-y_3)*(yc-y_4)<=0.0d0)) then
            intsct = 1
        else 
            intsct = 2
        end if
    end if
end if
end
!b-------------------------------------------------------------------------

!c-------------------------------------------------------------------------    
! relation between two points; distance 'dab' between two points 'pta (xa,ya)', 'ptb(xb,yb)'
subroutine distance2D(pta,ptb,dab,id_distance2D)
implicit none

real(kind = 8), parameter :: zero8 = 1.0d-8
real(kind = 8) :: pta(2), ptb(2)
real(kind = 8) :: dab
integer :: id_distance2D

id_distance2D = 0                                                   ! point a and b don't conincide

dab = dsqrt((ptb(1)-pta(1))*(ptb(1)-pta(1)) + (ptb(2)-pta(2))*(ptb(2)-pta(2)))

if (dab<=zero8) then
    dab = 0.0d0
    id_distance2D = 1                       ! coincide
end if

end
!c-------------------------------------------------------------------------

!d-------------------------------------------------------------------------     
! relation between 3 points in a plane; projection of a point on a line defined by two different points
subroutine projection2D(line_pt1,line_pt2,test_p,n_pt,id_projection)
implicit none

real(kind = 8), parameter :: zero = 1.0d-16
real(kind = 8) :: line_pt1(2), line_pt2(2), test_p(2), n_pt(2)
integer :: id_projection

id_projection = 0               ! initial value
n_pt = -2.0d0

if (((line_pt2(1)-line_pt1(1))*(line_pt2(1)-line_pt1(1))+(line_pt2(2)-line_pt1(2))*(line_pt2(2)-line_pt1(2)))<=zero) then
    id_projection = -3       ! two points defining the line coincide
    n_pt = dsqrt((test_p(1)-line_pt1(1))*(test_p(1)-line_pt1(1))+(test_p(2)-line_pt1(2))*(test_p(2)-line_pt1(2)))
else
    if ((((test_p(1)-line_pt1(1))*(test_p(1)-line_pt1(1))+(test_p(2)-line_pt1(2))*(test_p(2)-line_pt1(2)))<=zero).or.(((test_p(1)-line_pt2(1))*(test_p(1)-line_pt2(1))+(test_p(2)-line_pt2(2))*(test_p(2)-line_pt2(2)))<=zero)) then
        id_projection = -4          ! test point coincides with line points
        n_pt = line_pt1
        !n_pt = line_pt2
    else
        if ((dabs((line_pt1(1)-test_p(1))*(line_pt2(1)-line_pt1(1))+(line_pt1(2)-test_p(2))*(line_pt2(2)-line_pt1(2)))<=zero)) then
            id_projection = 1
            n_pt = line_pt1
        else if ((dabs((line_pt2(1)-test_p(1))*(line_pt2(1)-line_pt1(1))+(line_pt2(2)-test_p(2))*(line_pt2(2)-line_pt1(2)))<=zero)) then
            id_projection = 1
            n_pt = line_pt2
        else 
            if (dabs((line_pt2(1)-line_pt1(1))*(test_p(2)-line_pt1(2))-(test_p(1)-line_pt1(1))*(line_pt2(2)-line_pt1(2)))<=zero) then
                id_projection = -1              ! test point is in line with the other two points
                n_pt = test_p
            else
                id_projection = 1               ! perpendicular point
                n_pt(1) = (test_p(1)*(line_pt2(1)-line_pt1(1))*(line_pt2(1)-line_pt1(1))+line_pt1(1)*(line_pt2(2)-line_pt1(2))*(line_pt2(2)-line_pt1(2))+(line_pt2(1)-line_pt1(1))*(line_pt2(2)-line_pt1(2))*(test_p(2)-line_pt1(2)))/((line_pt2(1)-line_pt1(1))*(line_pt2(1)-line_pt1(1))+(line_pt2(2)-line_pt1(2))*(line_pt2(2)-line_pt1(2)))
                n_pt(2) = (test_p(2)*(line_pt2(2)-line_pt1(2))*(line_pt2(2)-line_pt1(2))+line_pt1(2)*(line_pt2(1)-line_pt1(1))*(line_pt2(1)-line_pt1(1))+(line_pt2(1)-line_pt1(1))*(line_pt2(2)-line_pt1(2))*(test_p(1)-line_pt1(1)))/((line_pt2(1)-line_pt1(1))*(line_pt2(1)-line_pt1(1))+(line_pt2(2)-line_pt1(2))*(line_pt2(2)-line_pt1(2)))
            end if
        end if
    end if
end if
end